using System;
using System.IO;
using System.Security.Cryptography;
using System.Text;

namespace Mail
{
	/// <summary>
    ///        .
	/// </summary>
	public class AttachDescriptor
	{
		string _oldname;
		string _tmpfile;

		internal AttachDescriptor(string name, string dir)
		{
			_oldname = name;
			_tmpfile = dir + Guid.NewGuid();
		}
		/// <summary>
		///   .
		/// </summary>
		/// <param name="message">    .</param>
		/// <param name="transform"> .</param>
		internal void DecodeFile(string message, ICryptoTransform transform)
		{
			try 
			{
				//   .
				FileStream tf = new FileStream(_tmpfile, FileMode.Create, FileAccess.Write);
				//      .
				CryptoStream cs = new CryptoStream(tf, transform, CryptoStreamMode.Write);
				
				//      
				Encoding enc = Encoding.ASCII;
				byte [] b = enc.GetBytes(message);
				//     .
				cs.Write(b, 0, b.Length);
				//  .
				cs.Close();
				tf.Close();
			} 
			//    .
			catch(System.Exception e)
			{
				Console.WriteLine(e.ToString());
				throw new ParseException("   ", e);
			}
		}
		/// <summary>
		///       .
		/// </summary>
		internal void Close()
		{
			File.Delete(_tmpfile);            
		}

		/// <summary>
        ///         .
		/// </summary>
		/// <returns></returns>
		public FileStream GetFile()
		{
			FileStream tf = new FileStream(_tmpfile, FileMode.Open, FileAccess.Read);
			return tf;
		}

		#region Public properties
        /// <summary>
        /// .
        /// </summary>
		public string Name
		{
			get
			{
                return _oldname;
			}
		}
        /// <summary>
        ///  .
        /// </summary>
		public string TempFile
		{
			get
			{
				return _tmpfile;
			}
		}
        /// <summary>
        /// .
        /// </summary>
		public long Size
		{
			get
			{
				FileInfo fi = new FileInfo(_tmpfile);
				return fi.Length;
			}
		}
		#endregion
	}
}