namespace Mail.Providers
{
	using System;
	using System.IO;
	using System.Diagnostics;
	using System.Text;

	/// <summary>
	///   .eml .
	/// </summary>
	public class MessageFile : Provider
	{
		const string FiveOctalTerm = "\r\n.\r\n";

		FileStream fs = null;

		/// <summary>
		/// .
		/// </summary>
		/// <param name="filename">  .</param>
		public MessageFile(string filename)
		{
            fs = new FileStream(filename, FileMode.Open, FileAccess.Read);
			TempDirectory = Path.GetTempPath();
		}

		/// <summary>
        ///  
		/// </summary>
		/// <param name="i"></param>
		public override void DeleteMessage(uint index)
		{
            Debug.WriteLine(" ");
		}

		string TruncateTail(string message)
		{
			if (!message.EndsWith(FiveOctalTerm))
			{
                Debug.WriteLine(" 5 : {" + message.Substring(message.Length - 5) + "}");
                throw new ResponseException("   .");
			}

			return message.Remove(message.Length - FiveOctalTerm.Length, FiveOctalTerm.Length);
		}

		/// <summary>
		///  .
		/// </summary>
		/// <param name="i"></param>
		public override Message GetMessage(uint index)
		{
			byte [] buf = new byte[fs.Length];
			fs.Read(buf, 0, buf.Length);
			fs.Position = 0;

			string message = Utils.RemoveByteStuffedSequence(Encoding.ASCII.GetString(buf));
			return new Message(this, message, index);
		}

		/// <summary>
		///   .
		/// </summary>
		/// <param name="name"></param>
		/// <param name="pass"></param>
		public override void LogIn(string name, string pass)
		{
            Debug.WriteLine(" ");
		}

		/// <summary>
		///  .
		/// </summary>
		public override void Dispose()
		{
			try
			{
				Quit();
			} 
			catch
			{
			}

            GC.SuppressFinalize(this);			
		}

		/// <summary>
		///  FilStream.
		/// </summary>
		public override void Quit()
		{
            fs.Close();
		}
	}
}
